<template>
  <div id="statement">
    <div class="statespace" v-for="(wgtId,index) in wgtArr" :key="index">
      <component name="wgt" :is="template(wgtId)" ref="tirget" v-if="tirget"></component>
    </div>
    <div class="statespace" v-for="wgtId in config.setting.appM" :key="wgtId">
      <component name="wgt" :is="template(wgtId)" ref="tirget" v-if="tirget"></component>
    </div>
    <div class="statespace" v-for="wgtId in config.setting.appR" :key="wgtId">
      <component name="wgt" :is="template(wgtId)" ref="tirget" v-if="tirget"></component>
    </div>
    <!-- <div v-wechat-title="$root.name"></div> -->
  </div>
</template>
<script>

import API from "@/api.js";
import view_delegate from "@/components/view_delegate.vue";
import widget_system_workflow from "@/components/widget_system_workflow.vue";
import widget_statement from "@/components/widget_statement.vue";
import widget_iscript from "@/components/widget_iscript.vue";
import widget_view from "@/components/widget_view.vue";
import widget_chart from "@/components/widget_chart.vue";
import widget_carboncopy from "@/components/widget_carboncopy.vue";
import widget_link from "@/components/widget_link.vue";
import widget_swipe from "@/components/widget_swipe.vue";
export default {
  inject: ["reload"],
  components: { 
    view_delegate, 
    widget_statement, 
    widget_iscript, 
    widget_view, 
    widget_chart,
    widget_link,
    widget_swipe,
  },
  created() {
    API.getHomePageConfig({
      onSucess: response => {
        let config = response.data.data;
        this.config = config;

        let widgetsArr = response.data.data.widgets;
        
        let appId = this.$root.appid;
        let wgtArr = [];
        let flow = '';
        for(let key in widgetsArr) {
          if(widgetsArr[key].id == "system_workflow") {
            flow = widgetsArr[key];
          }
          if(widgetsArr[key].applicationId == appId) {
            wgtArr.push(widgetsArr[key]);
          }
        }
        if(wgtArr.length > 0) {
          let min;
          for(let j=0; j<wgtArr.length; j++) {
            for(let z=j; z<wgtArr.length; z++){
              if(wgtArr[j].orderno > wgtArr[z].orderno){
                min = wgtArr[z];
                wgtArr[z] = wgtArr[j];
                wgtArr[j]=min; 
              }
            }
          }
        }
        if(flow) {
          wgtArr.splice(0,0,flow);
        }
        this.wgtArr = wgtArr;
      }
    });
    // this.$api.getHomePageConfigWithPhone(this.$root.appid, {  //现在只有流程处理，所以放在这里判断，之后首页有报表等更多时，移到组件main_homepage进行判断
    //   onSucess: response => {
    //     this.system_workflow = response.data.data.system_workflow;
    //     //  v-if="system_workflow == 'true' || system_workflow == true"
    //   }
    // })
  },

  data: function() {
    return {
      config: {
        setting: {
          appIcon: [],
          appL: [],
          appM: [],
          layoutStyle: "",
          appR: [],
          system_workflow:'',
          widget_carboncopy
        }
      },
      tirget: true, //控制流程处理显示和隐藏
      wgtArr:[],
      currentUrl: '',
      pagePath:'',
    };
  },

  methods: {
    //动态的显示两个组件
    template(wgtId) {
      //let wgt = this.config.widgets[wgtId];
      let wgt = wgtId;
       let that = this;
      if (wgt) {
        if (wgt.type == "customizeReport") { //报表
          if((this.$root.appid == wgt.applicationId && wgt.widgetType == 0) || (this.$root.appid == wgt.applicationId && wgt.widgetType == 2)) {
            this.$api.getCustomreports(wgt.actionContent,
              {
                onSucess: response => {
                  let urls = response.data;
                  if(urls.split("=")[2]) {
                    let arr = urls.split("=")[2];
                    if(arr.split(";")[0]) {
                      let arr2 = arr.split(";")[0];
                      if(arr2.split("'")[1]) {
                        this.currentUrl = arr2.split("'")[1];
                      }
                    }
                  }else {
                    this.currentUrl = obpmConfig.obpmFilePath + urls;
                  }
                }
              }
            );
            return {
              components: { widget_statement },
              methods: {
                getParams() {
                  return {
                    id: wgtId,
                    reportData: wgt,
                    path: that.currentUrl,
                  };
                }
              },
              template: "<div><widget_statement :report='getParams()'/></div>"
            };
          }else {
            return "";
          }
        } else if (wgt.type == "system_workflow") { //流程处理
          // if(this.system_workflow == 'true' || this.system_workflow == true) {
          if(wgt.widgetType == 0 || wgt.widgetType == 2) {
            return {
              methods: {
                getParams() {
                  return {
                    id: wgtId,
                    data: wgt,
                  };
                }
              },
              components: { widget_system_workflow },
              template: "<div><widget_system_workflow :data='getParams()' /></div>"
            };
          }else {
            return "";
          }
          // }else {
          //   return "";
          // }
        } else if(wgt.type ==  "carboncopy") {
          return {
            methods: {
              doAction(type, item, val) {
                that.doAction(type, item, val);
              },
              getParams() {
                return {
                  id: wgtId,
                  systemData: wgt,
                };
              }
            },
            components: { widget_carboncopy },
            template: "<div><widget_carboncopy :systemData='getParams()' @event='doAction'/></div>"
          };
        }else if (wgt.type == "view") { //视图
          if((this.$root.appid == wgt.applicationId && wgt.widgetType == 0) || (this.$root.appid == wgt.applicationId && wgt.widgetType == 2)) {
            return {
              components: { widget_view },
              methods: {
                getParams() {
                  return {
                    id: wgtId,
                    viewData: wgt,
                  };
                }
              },
              template: "<div><widget_view :view='getParams()'/></div>"
            };
          }else {
            return "";
          }
        }else if (wgt.type == 'iscript') {//摘要
          if((this.$root.appid == wgt.applicationId && wgt.widgetType == 0) || (this.$root.appid == wgt.applicationId && wgt.widgetType == 2)) {
            return {
              components: { widget_iscript },
              methods: {
                getParams() {
                  return {
                    id: wgtId,
                    wgtData: wgt,
                  };
                }
              },
              template: "<div><widget_iscript :iscript='getParams()'/></div>"
            };
          }else {
            return "";
          }
        }else if (wgt.type == 'chart') {
          if((this.$root.appid == wgt.applicationId && wgt.widgetType == 0) || (this.$root.appid == wgt.applicationId && wgt.widgetType == 2)) {
            return {
              components: { widget_chart },
              methods: {
                getParams() {
                  return {
                    id: wgtId,
                    wgtData: wgt,
                  };
                }
              },
              template: "<div><widget_chart :chart='getParams()'/></div>"
            };
          }else {
            return "";
          }
        }else if(wgt.type == 'page') {
          if((this.$root.appid == wgt.applicationId && wgt.widgetType == 0) || (this.$root.appid == wgt.applicationId && wgt.widgetType == 2)) {
            return {
              components: { widget_link },
              methods: {
                getParams() {
                  return {
                    wgtData: wgt,
                  };
                }
              },
              template: "<div><widget_link :link='getParams()'/></div>"
            };
          }else {
            return "";
          }
        }else if(wgt.type == 'carousel') {
          return {
            components: { widget_swipe },
            methods: {
              getParams() {
                return {
                  wgtData: wgt,
                };
              }
            },
            template: "<div><widget_swipe :swipe='getParams()'/></div>"
          };
        }
      }
    },

  }
};
</script>
